﻿Type=Activity
Version=1.70
FullScreen=False
IncludeTitle=True
@EndOfDesignText@
'Activity module
'version 4.0
Sub Process_Globals
	Dim SQL6 As SQL
End Sub

Sub Globals
	Dim scvList As ScrollView
	Dim Header As Panel
	Dim Table As Panel
'	Dim SelectedItems As Map
	Dim SelectedItems As List
	Dim btnAdd, btnDelete, btnModif, btnClear, btnUp, btnDown As Button
	Dim edtDateTime, edtTime, edtLat, edtLon, edtLocat, edtDepth, edtWeight, edtDetect, edtCoil As EditText
	Dim pnlEdit, pnlMove As Panel
	
	Dim NumberOfRows As Int						: NumberOfRows=0
	Dim PreviousRow As Int						: PreviousRow=-1
	Dim NumberOfVisibleRows As Int	
	Dim NumberOfColumns As Int				: NumberOfColumns = 8  'will be overwritten when loading from CscvList file.
	Dim RowHeight, RowHeight_1, RowLineWidth As Int
		RowLineWidth = 1dip
		RowHeight = 30dip
		RowHeight_1 = RowHeight - RowLineWidth
	
	Type RowCol (Row As Int, Col As Int)
	Dim LineColor  As Int							: LineColor = Colors.Blue
	Dim ColumnWidth(9) As Int
	Dim ColumnWidth_1(8) As Int
	Dim ColLineWidth As Int						: 	ColLineWidth = 1dip
	Dim SelectedRowColor As Int				: SelectedRowColor=Colors.RGB(255,196,196)
	Dim SelectedCellColor As Int			: SelectedCellColor=Colors.Red
	Dim DBFileName As String					: DBFileName="myfinds.db"
	Dim DBFilePath As String					: DBFilePath=File.DirDefaultExternal
	
	'Table settings
	Dim HeaderColor(8) As Int
		HeaderColor(0)=Colors.RGB(0,255,255)
		HeaderColor(1)=Colors.RGB(0,255,255)
		HeaderColor(2)=Colors.RGB(0,255,255)
		HeaderColor(3)=Colors.RGB(0,255,255)
		HeaderColor(4)=Colors.RGB(0,255,255)
		HeaderColor(5)=Colors.RGB(0,255,255)
		HeaderColor(6)=Colors.RGB(0,255,255)
		HeaderColor(7)=Colors.RGB(0,255,255)
		
	
	Dim HeaderFontColor(8) As Int
		HeaderFontColor(0)=Colors.Red
		HeaderFontColor(1)=Colors.Red
		HeaderFontColor(2)=Colors.Red
		HeaderFontColor(3)=Colors.Red
		HeaderFontColor(4)=Colors.Red
		HeaderFontColor(5)=Colors.Red
		HeaderFontColor(6)=Colors.Red
		HeaderFontColor(7)=Colors.Red
		
	
	Dim CellColor(8) As Int
		CellColor(0) = Colors.White
		CellColor(1) = Colors.White
		CellColor(2) = Colors.White
		CellColor(3) = Colors.White
		CellColor(4) = Colors.White
		CellColor(5) = Colors.White
		CellColor(6) = Colors.White
		CellColor(7) = Colors.White
		
	
	Dim FontColor(8) As Int
		FontColor(0) = Colors.Black
		FontColor(1) = Colors.Black
		FontColor(2) = Colors.Black
		FontColor(3) = Colors.Black
		FontColor(4) = Colors.Black
		FontColor(5) = Colors.Black
		FontColor(6) = Colors.Black
		FontColor(7) = Colors.Black
		
	
	Dim FontSize(8) As Float
		FontSize(0) = 12
		FontSize(1) = 12
		FontSize(2) = 12
		FontSize(3) = 12
		FontSize(4) = 12
		FontSize(5) = 12
		FontSize(6) = 12
		FontSize(7) = 12
		
	
	Dim Alignment(8) As Int
		Alignment(0) = Gravity.CENTER 'change to Gravity.LEFT or Gravity.RIGHT for other alignments.
		Alignment(1) = Gravity.CENTER
		Alignment(2) = Gravity.CENTER
		Alignment(3) = Gravity.CENTER 
		Alignment(4) = Gravity.CENTER
		Alignment(5) = Gravity.CENTER
		Alignment(6) = Gravity.CENTER
		Alignment(7) = Gravity.CENTER
		
End Sub

Sub Activity_Create(FirstTime As Boolean)
	Dim i As Int
	
	Activity.LoadLayout("Page6")

	scvList.Panel.Color=Colors.Black
	Table = scvList.Panel
	Table.Color = LineColor

'	ColumnWidth(0) = ColLineWidth					' hides the first column
'	ColumnWidth(1) = scvList.Width / 2		' sets the remaining column widths 1/2 screen width
'	ColumnWidth(2) = scvList.Width / 2
	ColumnWidth(0) = 0.125 * scvList.Width		
	ColumnWidth(1) = 0.125 * scvList.Width
	ColumnWidth(2) = 0.125 * scvList.Width
	ColumnWidth(3) = 0.125 * scvList.Width
	ColumnWidth(4) = 0.125 * scvList.Width
	ColumnWidth(5) = 0.125 * scvList.Width
	ColumnWidth(6) = 0.125 * scvList.Width
	ColumnWidth(7) = 0.125 * scvList.Width
	
	For i=0 To NumberOfColumns-1
		' sets the label width to the column width minus column line width
		ColumnWidth_1(i) = ColumnWidth(i)-ColLineWidth	
	Next
	SelectedItems.Initialize

	If File.Exists(DBFilePath, DBFileName)=False Then
		If FirstTime Then 
			SQL6.Initialize(DBFilePath, DBFileName, True)
		End If
'		SQLCreateTable
	Else
		If FirstTime Then 
			SQL6.Initialize(DBFilePath, DBFileName, True)
		End If
	End If
	
	SQLReadTable
	NumberOfVisibleRows=scvList.Height/RowHeight
End Sub

Sub Activity_Resume

End Sub

Sub Activity_Pause (UserClosed As Boolean)

End Sub

'Sub SQLCreateTable
'	SQL6.ExecNonQuery("DROP TABLE IF EXISTS table1")
'	SQL6.ExecNonQuery("CREATE TABLE table1 (Code TEXT , First TEXT, Name TEXT)")
'	SQLFillTable
'End Sub

'Sub SQLFillTable
'' Fills a SQL data base
'	Dim i As Int
'	
'	SQL6.BeginTransaction
'	Try
'		For i = 1 To 30
'			SQL6.ExecNonQuery2("INSERT INTO table1 VALUES (?, ?, ?)", Array As Object(1000+i, "First"&i, "Name"&i))
'		Next
'		SQL6.TransactionSuccessful
'	Catch
'		Log(LastException.Message)
'	End Try
'	SQL6.EndTransaction
'End Sub

Sub SQLReadTable
' Reads the SQL data base
	Dim i As Int
	Dim Cursor1 As Cursor

	Cursor1 = SQL6.ExecQuery("SELECT datetime, lat, lon, location, depth, weight, detector, coil FROM finds")

	Dim row(NumberOfColumns) As String
	row(0)="DateTime"
	row(1)="Lat"
	row(2)="Lon"
	row(3)="location"
	row(4)="Depth"
	row(5)="Weight"
	row(6)="Detector"
	row(7)="Coil"
	SetHeader(row)
	NumberOfRows=0
	For i = 0 To Cursor1.RowCount - 1
		Dim row(NumberOfColumns) As String
		Cursor1.Position = i
		row(0)=Cursor1.GetString("DateTime")
		row(1)=Cursor1.GetString("Lat")
		row(2)=Cursor1.GetString("Lon")
		row(3)=Cursor1.GetString("Location")
		row(4)=Cursor1.GetString("Depth")
		row(5)=Cursor1.GetString("Weight")
		row(6)=Cursor1.GetString("Detector")
		row(7)=Cursor1.GetString("Coil")
		AddRow(Row)
	Next
	Cursor1.Close
End Sub

Sub Cell_Click
	Dim rc As RowCol
	Dim l As Label
	l = Sender
	rc = l.Tag

	If SelectedItems.Size=1 Then
		SelectRow(rc.Row, rc.Col,2)
	Else
		SelectRow(rc.Row, rc.Col,0)
	End If
	SelectAdd
End Sub

Sub Cell_LongClick
	' activates multiselection
	If SelectedItems.Size=1 Then
		Dim rc As RowCol
		Dim l As Label
		l = Sender
		rc = l.Tag
		SelectRow(rc.Row, rc.Col,0)
		SelectAdd
		edtDateTime.Text=""
		edtLat.Text=""
		edtLon.Text=""
		edtLocat.Text=""
		edtDepth.Text=""
		edtWeight.Text=""
		edtDetect.Text=""
		edtCoil.Text=""
	Else
		Cell_Click
	End If
End Sub

Sub SelectAdd
	Dim txt As String

	txt="Codes = "
	For i=0 To SelectedItems.Size-1
		If i=0 Then
			txt=txt&GetView(SelectedItems.Get(i),0).Text
		Else
			txt=txt&" / "&GetView(SelectedItems.Get(i),0).Text
		End If
	Next
	Activity.Title = txt
End Sub

Sub Header_Click
	Dim l As Label
	Dim col As Int
	l = Sender
	col = l.Tag
	Activity.Title = "Header clicked: " & col
End Sub

Sub SelectRow(Row As Int, SelCol As Int, Mode As Int)
	' Mode = 0 -> multi selection
	'      = 1 -> up / down move
	'      = 2 -> mono selection
	Dim col, index As Int

	index=SelectedItems.IndexOf(Row)  ' tests if the row is alrady selected
	
	If index>-1 Then ' row already selected
		For col = 0 To NumberOfColumns - 1
			GetView(Row, Col).Color = CellColor(col)  ' remove the color of previously selected row
		Next
		SelectedItems.RemoveAt(index)	' removes the row from the list of selected rows
		If SelectedItems.Size=1 Then
			Row=SelectedItems.Get(0)		' sets row to the last selected row
		End If
	Else
		' adds the selected row to the list and sets the line color
		If Mode=0 Then
			SelectedItems.Add(Row)
		Else If Mode=2 Then
			For col = 0 To NumberOfColumns - 1
				GetView(PreviousRow, Col).Color = CellColor(col)  ' sets standard colors to previous row
			Next
		End If
		For col = 0 To NumberOfColumns - 1
			GetView(Row, Col).Color = SelectedRowColor  ' sets selected row colors
		Next
	End If
	
	If Mode=1 Then	' up / down move
		For col = 0 To NumberOfColumns - 1
			GetView(PreviousRow, Col).Color = CellColor(col)
			GetView(Row, Col).Color = SelectedRowColor
		Next
	End If
	
	' update or the Buttons and EditText views
	If SelectedItems.Size=0 Then
'		pnlMove.Visible=False
		btnModif.Visible=False
		btnDelete.Visible=False
		btnClear.Visible=True
	Else If SelectedItems.Size=1 Then
		SelectedItems.Set(0,Row)
		edtDateTime.Text=GetView(SelectedItems.Get(0), 0).Text	
		edtLat.Text=GetView(SelectedItems.Get(0), 1).Text
		edtLon.Text=GetView(SelectedItems.Get(0), 2).Text
		edtLocat.Text=GetView(SelectedItems.Get(0), 3).Text
		edtDepth.Text=GetView(SelectedItems.Get(0), 4).Text
		edtWeight.Text=GetView(SelectedItems.Get(0), 5).Text
		edtDetect.Text=GetView(SelectedItems.Get(0), 6).Text
		edtCoil.Text=GetView(SelectedItems.Get(0), 7).Text
'		pnlMove.Visible=True
		btnModif.Visible=True
		btnDelete.Visible=True
		btnClear.Visible=False
		PreviousRow=Row
	Else
'		pnlMove.Visible=False
		btnModif.Visible=False
		btnDelete.Visible=True
		btnClear.Visible=False
	End If
End Sub

Sub GetView(Row As Int, Col As Int) As Label
' Returns the label in the specific cell
	Dim l As Label
	l = Table.GetView(Row * NumberOfColumns + Col)
	Return l
End Sub

Sub AddRow(Values() As String)
' Adds a row to the table
	Dim ColWidth As Int
	
	If values.Length <> NumberOfColumns Then
		Log("Wrong number of values.")
		Return
	End If
	ColWidth=0
	For i = 0 To NumberOfColumns - 1
		Dim l As Label
		l.Initialize("cell")
		l.Text = values(i)
		l.Gravity = Alignment(i)
		l.TextSize = FontSize(i)
		l.TextColor = FontColor(i)
		l.Color=CellColor(i)
		Dim rc As RowCol
		rc.Initialize
		rc.Col = i
		rc.Row = NumberOfRows
		l.Tag = rc
		Table.AddView(l, ColWidth, RowHeight * NumberOfRows, ColumnWidth_1(i), RowHeight_1)
		ColWidth=ColWidth+ColumnWidth(i)
	Next
	NumberOfRows=NumberOfRows+1
	Table.Height = NumberOfRows * RowHeight
End Sub

Sub SetHeader(Values() As String)
' Set the headers values
	Dim ColWidth As Int

	If header.IsInitialized Then Return 'should only be called once
	header.Initialize("")
	ColWidth=0
	For i = 0 To NumberOfColumns - 1
		Dim l As Label
		l.Initialize("header")
		l.Text = values(i)
		l.Gravity = Alignment(i)
		l.TextSize = FontSize(i)
		l.Color = HeaderColor(i)
		l.TextColor = HeaderFontColor(i)
		l.Tag = i
		header.AddView(l, ColWidth, 0, ColumnWidth_1(i), RowHeight_1)
		ColWidth=ColWidth+ColumnWidth(i)
	Next
	Activity.AddView(header, scvList.Left, scvList.Top - RowHeight, scvList.Width, RowHeight)
End Sub

Sub SetCell(Row As Int, Col As Int, Value As String)
' Sets the value of the given cell
	GetView(Row, Col).Text = value
End Sub

Sub GetCell(Row As Int, Col As Int) As String
' Gets the value of the given cell
	Return GetView(Row, Col).Text
End Sub

Sub ClearAll
' Clears the table
	For i = Table.NumberOfViews -1 To 0 Step -1
		Table.RemoveViewAt(i)
	Next
	Table.Height = 0
	SelectedItems.Clear
End Sub

Sub btnAdd_Click
	Dim row(NumberOfColumns) As String
	Dim hh As Int
	
	If edtDateTime.Text="" OR edtLat.Text="" OR edtLon.Text="" OR edtLocat.Text="" OR edtDepth.Text="" OR edtWeight.Text="" OR edtDetect.Text="" OR edtCoil.Text="" Then
		Msgbox("There are missing data","Attention")
		Return
	End If
	
	row(0)=edtDateTime.Text
	row(1)=edtLat.Text
	row(2)=edtLon.Text
	row(3)=edtLocat.Text
	row(4)=edtDepth.Text
	row(5)=edtWeight.Text
	row(6)=edtDetect.Text
	row(7)=edtCoil.Text
	AddRow(row)
	If NumberOfRows>0 Then
		btnClear.Visible=True
		btnModif.Visible=True
	End If

	SQL6.ExecNonQuery2("INSERT INTO Finds VALUES (?,?,?,?,?,?,?,?)",row)

	DoEvents
	hh=(NumberOfRows - NumberOfVisibleRows+1) * RowHeight
	If hh<0 Then
		hh=0
	End If
	scvList.ScrollPosition=hh
	DoEvents
End Sub

Sub btnDelete_Click
	Dim row, col, Answ, Index As Int
	Dim i As Int
	Answ=Msgbox2("Do you really want to delete the selected rows","A T T E N T I O N","Yes","","No",Null)
	If Answ=DialogResponse.POSITIVE Then
		Do While SelectedItems.Size> 0
			row=SelectedItems.Get(0)
			For col=0 To NumberOfColumns - 1
				GetView(Row, Col).Color = CellColor(col)			
			Next
			List_Delete(row, 0)
			For i=0 To SelectedItems.Size-1
				Index=SelectedItems.Get(i)
				If Index>row Then
					SelectedItems.Set(i,Index-1)
				End If
			Next
			SelectedItems.RemoveAt(0)
		Loop
'		pnlEdit.Visible=False
'		pnlMove.Visible=False
		btnModif.Visible=False
		btnDelete.Visible=False
		edtDateTime.Text=""
		edtLat.Text=""
		edtLon.Text=""
		edtLocat.Text=""
		edtDepth.Text=""
		edtWeight.Text=""
		edtDetect.Text=""
		edtCoil.Text=""
	End If
End Sub

Sub btnModif_Click
	Dim row(NumberOfColumns) As String
	
	row(0)=edtDateTime.Text
	row(1)=edtLat.Text
	row(2)=edtLon.Text
	row(3)=edtLocat.Text
	row(4)=edtDepth.Text
	row(5)=edtWeight.Text
	row(6)=edtDetect.Text
	row(7)=edtCoil.Text
	SQL6.BeginTransaction
	SQL6.ExecNonQuery("UPDATE finds Set DateTime = '"&row(0)&"', Lat = '"&row(1)&"', Lon = '"&row(2)&"', Location = '"&row(3)&"', Depth = '"&row(4)&"', Weight = '"&row(5)&"', Detector = '"&row(6)&"', Coil = '"&row(7)&"' WHERE DateTime = '" & GetView(SelectedItems.Get(0),0).Text & "'")
	SQL6.EndTransaction	
	For i=0 To NumberOfColumns-1
		SetCell(SelectedItems.Get(0),i,row(i))
	Next
		
End Sub

Sub btnClear_Click
	Dim Answ, i As Int
	
	Answ=Msgbox2("Do you really want to clear the whole database ?","A T T E N T I O N","Yes","","No",Null)
	If Answ=DialogResponse.POSITIVE Then
		For i=Table.NumberOfViews-1 To 0 Step -1
			Table.RemoveViewAt(i)
		Next
		SelectedItems.Clear
		NumberOfRows=0
'		pnlEdit.Visible=True
		btnClear.Visible=False
		btnDelete.Visible=False
		btnModif.Visible=False
	End If
End Sub

'Sub btnUp_Click
'	Dim txt As String
'	Dim row, col, hh As Int
'	
'	row=SelectedItems.Get(0)
'	
'	If row>0 Then   ' tests if row is not the first one
'		For col=0 To NumberOfColumns-1  ' inverts the texts of the two rows
'			txt=GetView(row-1,col).Text
'			GetView(row-1,col).Text=GetView(row,col).Text
'			GetView(row,col).Text=txt
'		Next
'		SelectRow(row-1,0,1)		' selects the row before the selected one
'
'		' adjsusts the ScrollView position
'		hh=RowHeight*(row-1)
'		If hh<0 Then
'			hh=0
'		End If
'		If hh<scvList.ScrollPosition Then
'			scvList.ScrollPosition=hh
'			DoEvents
'		End If
'	End If
'End Sub

'Sub btnDown_Click
'	Dim txt As String
'	Dim row, col, hh As Int
'
'	row=SelectedItems.Get(0)
'	
'	If row<NumberOfRows-1 Then   ' tests if row is not the last one
'		For col = 0 To NumberOfColumns - 1   ' inverts the texts of the two rows
'			txt=GetView(row+1,col).Text
'			GetView(row+1,col).Text=GetView(row,col).Text
'			GetView(row,col).Text=txt
'		Next
'		SelectRow(row+1,0,1)		' selects the row after the selected one
'		
'		' adjsusts the ScrollView position
'		hh=RowHeight*(row-NumberOfVisibleRows+2)
'		If hh<0 Then
'			hh=0
'		End If
'		If hh>RowHeight*(NumberOfRows-NumberOfVisibleRows) Then
'			hh=RowHeight*(NumberOfRows-NumberOfVisibleRows)
'		End If
'		If hh>scvList.ScrollPosition Then
'			scvList.ScrollPosition=hh
'			DoEvents
'		End If
'	End If
'End Sub

Sub List_Delete(Row As Int, Col As Int)
	' Deletes one row
	Dim i, j, Answ As Int
	Dim txt As String
	
	SQL6.ExecNonQuery("DELETE FROM Finds WHERE Finds.DateTime = '" & GetView(Row,0).Text & "'")
	
	' updates the texts and tags of the rows above the deletetd row
	For i=Row To NumberOfRows-2
		For j=0 To NumberOfColumns-1
			GetView(i,j).Text=GetView(i+1,j).Text
			Dim rc As RowCol
			rc.Initialize
			rc.Row = i
			rc.Col = j
			GetView(i,j).Tag=rc
		Next
	Next
	
	' removes the last row
	For j=NumberOfColumns-1 To 0 Step -1
		Table.RemoveViewAt((NumberOfRows-1)*NumberOfColumns+j)
	Next

	NumberOfRows=NumberOfRows-1   ' updates the number of rowa
	If NumberOfRows>0 Then				' updates the ScrollView Panel height
		Table.Height = NumberOfRows * RowHeight
	Else
		Table.Height = RowHeight
	End If
End Sub

Sub btnBack_Click
	Activity.CloseMenu
	StartActivity ("Main")
		edtDateTime.Text=""
		edtLat.Text=""
		edtLon.Text=""
		edtLocat.Text=""
		edtDepth.Text=""
		edtWeight.Text=""
		edtDetect.Text=""
		edtCoil.Text=""
End Sub