﻿Type=Activity
Version=1.70
FullScreen=False
IncludeTitle=True
@EndOfDesignText@
Sub Process_Globals
	Dim Bitmaps As List
	Dim ImageTitles As List

End Sub

Sub Globals
	Dim scvPics As ScrollView
	Dim btmpex As BitmapExtended
	Dim bd2,bd3 As Bitmap
	
End Sub

Sub Activity_Create(FirstTime As Boolean)
	Dim i As Int
	Dim PictureHeight, LabelHeight, Margin, Margin_2, Margin_4, ItemHeight As Float
	
	PictureHeight = 190dip
	LabelHeight = 30dip
	Margin = 5dip
	Margin_2 = 2 * Margin
	Margin_4 = 2 * Margin_2
	ItemHeight = 3 * Margin + PictureHeight + LabelHeight
	
	If FirstTime Then 'only load the images once.
		ProgressDialogShow("Loading images")
		LoadImages
		ProgressDialogHide
	End If
'	btmpex.Initialize("BitmapExtended")
	Activity.LoadLayout("Page4") 'load the layout file
	scvPics.Panel.Height = ItemHeight * Bitmaps.Size 'Set the inner panel height according to the number of images.
	
	For i = 0 To Bitmaps.Size - 1
    Dim iv As ImageView 'create an ImageView for each bitmap
    iv.Initialize("") 'not interested in any events so we pass empty string.
    Dim bd As BitmapDrawable
    bd.Initialize(Bitmaps.Get(i))
    bd2 = bd.Bitmap
    bd3 = btmpex.rotateBitmap(bd2,90)
    iv.bitmap = bd3 'set the background of the image view.
    'add the image view to the scroll bar internal panel.
    scvPics.Panel.AddView(iv, Margin, Margin + i * ItemHeight, scvPics.Width - Margin_2, PictureHeight)
    'add the lable
    Dim lbl As Label
    lbl.Initialize("")
    lbl.Gravity = Gravity.CENTER_HORIZONTAL
    scvPics.Panel.AddView(lbl, Margin_2, Margin_2 + i * ItemHeight + PictureHeight, scvPics.Width - Margin_4, LabelHeight)
		lbl.Color = Colors.RGB(255, 190, 0)
		lbl.TextColor = Colors.RGB(165, 42, 42)
		lbl.TextSize = 16
		lbl.Text = ImageTitles.Get(i)
	Next
End Sub

Sub LoadImages
    Bitmaps.Initialize
    ImageTitles.Initialize
    Dim files As List
    Dim imagesFolder As String
'    imagesFolder = File.DirDefaultExternal
    imagesFolder = File.DirRootExternal
    If File.Exists(imagesFolder, "") = False Then
        ToastMessageShow("Images folder not found: " & CRLF & imagesFolder, True)
        Return
    End If
    files = File.ListFiles(imagesFolder) 'get all files in this folder
    For i = 0 To files.Size - 1
        DoEvents 'required for the ProgressDialog animation
        Dim f As String
        f = files.Get(i)
        If f.ToLowerCase.EndsWith(".jpg") Then
            Dim b As Bitmap
            b.InitializeSample(imagesFolder, f, 200dip, 200dip) 'load the jpeg file and subsample it if it is too large.
            Bitmaps.Add(b) 'add the bitmap to the bitmaps list.
            ImageTitles.Add(f)
            If Bitmaps.Size > 500 Then Exit 'limit it to 50 images
        End If
    Next
    ToastMessageShow("Found " & Bitmaps.Size & " images", True)
End Sub

Sub Activity_Resume

End Sub

Sub Activity_Pause (UserClosed As Boolean)

End Sub

Sub Share
Dim z As Intent
    z.Initialize(z.ACTION_SEND, "")
    z.SetType("image/jpeg")
    z.PutExtra("android.intent.extra.TEXT", "this is the message")
    z.WrapAsIntentChooser("Choose")
    StartActivity(z)
End Sub

Sub imvImage_Click

End Sub

Sub btnMain_Click
	Activity.CloseMenu
	StartActivity ("Main")
End Sub
